#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp
uniform sampler2D u_NoiseTexture;

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

#define BLOCK_SIZE 28.0
#define BLOCK_CTRL 0.1

float sat( float t ) {
    return clamp( t, 0.0, 1.0 );
}
vec2 sat( vec2 t ) {
    return clamp( t, 0.0, 1.0 );
}
float remap  ( float t, float a, float b ) {
    return sat( (t - a) / (b - a) );
}
float linterp( float t ) {
    return sat( 1.0 - abs( 2.0*t - 1.0 ) );
}
// this function and the ones above aren't mine
// they aren't really needed but I don't feel like
// removing them either
// I don't remember where they were from...
vec3 spectrum_offset( float t ) {
    vec3 ret;
    float lo = step(t,0.5);
    float hi = 1.0-lo;
    float w = linterp( remap( t, 1.0/6.0, 5.0/6.0 ) );
    float neg_w = 1.0-w;
    ret = vec3(lo,1.0,hi) * vec3(neg_w, w, neg_w);
    return pow( ret, vec3(1.0/2.2) );
}

float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

void main() {
    vec2 uv = gl_FragCoord.xy / u_Resolution.xy;
    vec2 aspect = vec2(1.0, u_Resolution.x/u_Resolution.y);
    /*if (u_Resolution.x > u_Resolution.y) {
        aspect = vec2(1.0,u_Resolution.x / u_Resolution.y);
        uv.y *= u_Resolution.y/u_Resolution.x;
    } else {
        aspect = vec2(u_Resolution.y / u_Resolution.x,1.0);
        uv.x *= u_Resolution.x / u_Resolution.y;
    }*/

    float time = u_Time;
    vec4 sum = texture(u_Texture, uv);

    //if (u_Resolution.x > u_Resolution.y) {
        uv.y *= u_Resolution.y/u_Resolution.x;
    //} else {
     //   uv.y /= u_Resolution.y / u_Resolution.x;
    //}

    const float amount = 6.0;

    for(float i = 0.0; i < amount; i++){
        uv /= pow(mix(vec2(1.0), fract(BLOCK_SIZE*uv)+0.5, clamp(pow(length(texture(u_NoiseTexture, vec2(0.06*u_Time)).xyz ), 15.0),0.0, 1.0)), vec2(BLOCK_CTRL));
        sum = clamp(sum, 0.15, 1.0);
        sum /= 0.1+0.9*clamp(texture(u_Texture, aspect*uv+vec2(1.0/u_Resolution.x,i/u_Resolution.y)),0.0,2.0);
        sum *= 0.1+0.9*clamp(texture(u_Texture, aspect*uv+vec2(1.0/u_Resolution.x,-i/u_Resolution.y)),0.0,2.0);
        sum *= 0.1+0.9*clamp(texture(u_Texture, aspect*uv+vec2(-i/u_Resolution.x,i/u_Resolution.y)),0.0,2.0);
        sum /= 0.1+0.9*clamp(texture(u_Texture, aspect*uv+vec2(-i/u_Resolution.x,-i/u_Resolution.y)),0.0,2.0);
        sum.xyz /= 1.01-0.025*spectrum_offset( 1.0-length(sum.xyz) );
        sum.xyz *= 1.0+0.01*spectrum_offset( length(sum.xyz) );

    }
    sum = 0.1+0.9*sum;
    float chromaf = pow(length(texture(u_NoiseTexture, vec2(0.0213*u_Time)).xyz ), 2.0);
    sum /= length(sum);
    sum = (-0.2+2.0*sum)*0.9;
    sum.a = 1.0;
    o_FragColor = sum;
}
