#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

float rand(vec2 co)
{
    return fract(sin(dot(co.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

void main() {
    vec2 uv = gl_FragCoord.xy / u_Resolution.xy;

    if (mod(u_Time, 2.0) > 1.9) {
        uv.x += cos(u_Time * 10.0 + uv.y * 1000.0) * 0.01;
    }

    //if (mod(u_Time, 4.0) > 3.0)
    //	uv = floor(uv * 32.0) / 32.0;

    if (mod(u_Time, 5.0) > 3.75) {
        uv += 1.0 / 64.0 * (2.0 * vec2(rand(floor(uv * 32.0) + vec2(32.05, 236.0)), rand(floor(uv.y * 32.0) + vec2(-62.05, -36.0))) - 1.0);
    }

    o_FragColor = texture(u_Texture, uv);

    if (rand(vec2(u_Time)) > 0.90) {
        o_FragColor = vec4(dot(o_FragColor.rgb, vec3(0.25, 0.5, 0.25)));
    }

    o_FragColor.rgb += 0.25 * vec3(rand(u_Time + gl_FragCoord.xy / vec2(-213, 5.53)), rand(u_Time - gl_FragCoord.xy / vec2(213, -5.53)), rand(u_Time + gl_FragCoord.xy / vec2(213, 5.53))) - 0.125;
    o_FragColor.a = 1.0;
}
