#version 300 es

precision highp float;

in vec2 v_TexCoord;
uniform sampler2D u_Image;
uniform sampler2D u_Mask;
uniform float u_InterMaskAlpha;
uniform sampler2D u_InterMask;
uniform int u_ApplyInterMask;
uniform int u_Restore;

layout(location = 0) out vec4 o_FragColor;

void main() {
    float a = texture(u_Mask, v_TexCoord).r;

    if (u_ApplyInterMask == 1) {
        float im = texture(u_InterMask, v_TexCoord).r * u_InterMaskAlpha;

        a = u_Restore == 1 ? a - im * a : im * (1.0 - a) + a;
        a = clamp(a, 0.0, 1.0);
    }

    o_FragColor = texture(u_Image, v_TexCoord) * (1.0 - a);
}