#version 300 es

precision highp float;

uniform sampler2D u_Texture;
uniform vec2 u_Resolution;
uniform vec2 u_Direction;
uniform int u_Type;

layout(location = 0) out vec4 o_FragColor;


vec4 blur5(vec2 texCoord) {
    vec4 color = vec4(0.0);
    vec2 off1 = vec2(1.3333333333333333) * u_Direction;

    color += texture(u_Texture, texCoord) * 0.29411764705882354;
    color += texture(u_Texture, texCoord + (off1 / u_Resolution)) * 0.35294117647058826;
    color += texture(u_Texture, texCoord - (off1 / u_Resolution)) * 0.35294117647058826;

    return color;
}

vec4 blur9(vec2 texCoord) {
    vec4 color = vec4(0.0);
    vec2 off1 = vec2(1.3846153846) * u_Direction;
    vec2 off2 = vec2(3.2307692308) * u_Direction;

    color += texture(u_Texture, texCoord) * 0.2270270270;
    color += texture(u_Texture, texCoord + (off1 / u_Resolution)) * 0.3162162162;
    color += texture(u_Texture, texCoord - (off1 / u_Resolution)) * 0.3162162162;
    color += texture(u_Texture, texCoord + (off2 / u_Resolution)) * 0.0702702703;
    color += texture(u_Texture, texCoord - (off2 / u_Resolution)) * 0.0702702703;

    return color;
}

vec4 blur13(vec2 texCoord) {
    vec4 color = vec4(0.0);
    vec2 off1 = vec2(1.411764705882353) * u_Direction;
    vec2 off2 = vec2(3.2941176470588234) * u_Direction;
    vec2 off3 = vec2(5.176470588235294) * u_Direction;

    color += texture(u_Texture, texCoord) * 0.1964825501511404;
    color += texture(u_Texture, texCoord + (off1 / u_Resolution)) * 0.2969069646728344;
    color += texture(u_Texture, texCoord - (off1 / u_Resolution)) * 0.2969069646728344;
    color += texture(u_Texture, texCoord + (off2 / u_Resolution)) * 0.09447039785044732;
    color += texture(u_Texture, texCoord - (off2 / u_Resolution)) * 0.09447039785044732;
    color += texture(u_Texture, texCoord + (off3 / u_Resolution)) * 0.010381362401148057;
    color += texture(u_Texture, texCoord - (off3 / u_Resolution)) * 0.010381362401148057;

    return color;
}


void main() {
    vec4 color;
    vec2 texCoord = gl_FragCoord.xy / u_Resolution;

    if (u_Type == 0) {
        color = blur5(texCoord);
    } else if (u_Type == 1) {
        color = blur9(texCoord);
    } else {
        color = blur13(texCoord);
    }

    o_FragColor = color;
}
