#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp
uniform sampler2D u_NoiseTexture;

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

void main() {
    vec2 uv = gl_FragCoord.xy / u_Resolution.xy;

    float t = u_Time;

    o_FragColor.rgb = vec3(texture(u_Texture, uv).r, texture(u_Texture, uv - 0.025 + cos(t + uv.y + uv.x)*0.1).g, texture(u_Texture, uv + 0.04  + sin(t + uv.y + uv.x)*0.1).b);
    o_FragColor.rgb *= 1.75;
    o_FragColor.a = 1.0;

    float a = t*0.25;

    o_FragColor.gb -= texture(u_NoiseTexture, (uv + length(uv) ) * mat2(cos(a), -sin(a), sin(a), cos(a))).gb*0.15 + length(uv - 0.5);

    o_FragColor.rgb -= length(uv - 0.5) * 0.75;
}
