#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453) * 2.0 - 1.0;
}

float offset(float blocks, vec2 uv) {
    return rand(vec2(u_Time, floor(uv.y * blocks)));
}


void main() {
    vec2 uv = gl_FragCoord.xy / u_Resolution.xy;

    o_FragColor = texture(u_Texture, uv);

    o_FragColor.r = texture(u_Texture, uv + vec2(offset(16.0, uv) * 0.03, 0.0)).r;
    o_FragColor.g = texture(u_Texture, uv + vec2(offset(8.0, uv) * 0.03 * 0.16666666, 0.0)).g;
    o_FragColor.b = texture(u_Texture, uv + vec2(offset(8.0, uv) * 0.03, 0.0)).b;
}
