#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

const float amount = .035;
const float speed = 2.5;

void main() {
    vec2 uv = gl_FragCoord.xy / u_Resolution.xy;
    vec2 uvRed = uv;
    vec2 uvBlue = uv;
    float s = abs(sin(u_Time * speed)) * amount;
    uvRed.x += s;
    uvBlue.x -= s;

    o_FragColor =  texture(u_Texture, uv);

    o_FragColor.r = texture(u_Texture, uvRed).r;
    o_FragColor.b = texture(u_Texture, uvBlue).b;
}
