#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

float rand(vec2 co)
{
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

void main() {
    vec2 uv = gl_FragCoord.xy / u_Resolution.xy;

    //tweak the factor (4.0) to change the intensity of the glitch effect
    float rnd = rand(vec2(u_Time)) * 4.0;

    if (mod(gl_FragCoord.y, rnd) > rnd / 8.0)
    {
        float of = sin(gl_FragCoord.y / rnd * u_Time) * rnd * 2.0;
        uv = vec2(gl_FragCoord.x + of, gl_FragCoord.y + of / 2.0) / u_Resolution.xy;
        o_FragColor = texture(u_Texture, uv);
        o_FragColor.r *= texture(u_Texture, uv + of * rnd * vec2(0.005, 0.0)).r;
        o_FragColor.g *= texture(u_Texture, uv).g;
        o_FragColor.b *= texture(u_Texture, uv - of * rnd * vec2(0.005, 0.0)).b;
        o_FragColor *= 1.5;
    } else
    {
        uv = vec2(gl_FragCoord.x - rnd * 4.0, gl_FragCoord.y + rnd / 2.0) / u_Resolution.xy;
        o_FragColor = texture(u_Texture, uv);
        o_FragColor.r *= texture(u_Texture, uv + rnd * vec2(0.05, 0.0)).r;
        o_FragColor.g *= texture(u_Texture, uv).g;
        o_FragColor.b *= texture(u_Texture, uv - rnd * vec2(0.05, 0.0)).b;
        o_FragColor *= 1.5;
    }

    o_FragColor.a = 1.0;
}
