#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;

layout(location = 0) out vec4 o_FragColor;

void main() {
    // normalized pixel coordinates
    vec2 p = 6.0*gl_FragCoord.xy/u_Resolution.xy;

    // pattern
    float f = sin(p.x + sin(2.0*p.y + u_Time)) +
    sin(length(p)+u_Time) +
    0.5*sin(p.x*2.5+u_Time);

    // color
    vec3 col = 0.7 + 0.3*cos(f+vec3(0,2.1,4.2));

    // putput to screen
    o_FragColor = vec4(col,1.0);
}
