#version 300 es

precision highp float;

uniform float u_Radius;
uniform float u_Hardness;
uniform vec2 u_Center;

layout(location = 0) out vec4 o_FragColor;

float map(float value, float inMin, float inMax, float outMin, float outMax) {
    return (value - inMin) * (outMax - outMin) / (inMax - inMin) + outMin;
}

void main() {
    float d = distance(u_Center, gl_FragCoord.xy);
    float i = d / u_Radius;
    float red = i <= u_Hardness ? 1.0 : (1.0 - (d - u_Hardness * u_Radius) / (u_Radius * (1.0 - u_Hardness)));

    o_FragColor = vec4(red, 0.0, 0.0, 1.0);
}
