#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

float rand () {
    return fract(sin(u_Time)*1e4);
}

void main() {
    vec2 uv = gl_FragCoord.xy / u_Resolution.xy;

    vec2 uvR = uv;
    vec2 uvB = uv;

    uvR.x = uv.x * 1.0 - rand() * 0.02 * 0.8;
    uvB.y = uv.y * 1.0 + rand() * 0.02 * 0.8;

    //
    if(uv.y < rand() && uv.y > rand() -0.1 && sin(u_Time) < 0.0)
    {
        uv.x = (uv + 0.02 * rand()).x;
    }

    //
    vec4 c;
    c.r = texture(u_Texture, uvR).r;
    c.g = texture(u_Texture, uv).g;
    c.b = texture(u_Texture, uvB).b;
    c.a = 1.0;

    //
    float scanline = sin( uv.y * 800.0 * rand())/30.0;
    c *= 1.0 - scanline;

    //vignette
    float vegDist = length(( 0.5 , 0.5 ) - uv);
    c *= 1.0 - vegDist * 0.6;

    o_FragColor = c;
}
