#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

float rand(float seed){
    return fract(sin(dot(vec2(seed) ,vec2(12.9898,78.233))) * 43758.5453);
}

vec2 displace(vec2 co, float seed, float seed2) {
    vec2 shift = vec2(0);
    if (rand(seed) > 0.5) {
        shift += 0.1 * vec2(2. * (0.5 - rand(seed2)));
    }
    if (rand(seed2) > 0.6) {
        if (co.y > 0.5) {
            shift.x *= rand(seed2 * seed);
        }
    }
    return shift;
}

vec4 interlace(vec2 co, vec4 col) {
    if (int(co.y) % 3 == 0) {
        return col * ((sin(u_Time * 4.) * 0.1) + 0.75) + (rand(u_Time) * 0.05);
    }
    return col;
}

void main() {
    vec2 uv = gl_FragCoord.xy/u_Resolution.xy;

    vec2 rDisplace = vec2(0);
    vec2 gDisplace = vec2(0);
    vec2 bDisplace = vec2(0);

    if (rand(u_Time) > 0.95) {
        rDisplace = displace(uv, u_Time * 2., 2. + u_Time);
        gDisplace = displace(uv, u_Time * 3., 3. + u_Time);
        bDisplace = displace(uv, u_Time * 5., 5. + u_Time);
    }

    rDisplace.x += 0.005 * (0.5 - rand(u_Time * 37. * uv.y));
    gDisplace.x += 0.007 * (0.5 - rand(u_Time * 41. * uv.y));
    bDisplace.x += 0.0011 * (0.5 - rand(u_Time * 53. * uv.y));

    rDisplace.y += 0.001 * (0.5 - rand(u_Time * 37. * uv.x));
    gDisplace.y += 0.001 * (0.5 - rand(u_Time * 41. * uv.x));
    bDisplace.y += 0.001 * (0.5 - rand(u_Time * 53. * uv.x));

    // Output to screen
    float rcolor = texture(u_Texture, uv.xy + rDisplace).r;
    float gcolor = texture(u_Texture, uv.xy + gDisplace).g;
    float bcolor = texture(u_Texture, uv.xy + bDisplace).b;

    o_FragColor = interlace(gl_FragCoord.xy, vec4(rcolor, gcolor, bcolor, 1));

}
