#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp
uniform sampler2D u_NoiseTexture;

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

void main() {
    vec2 uv = gl_FragCoord.xy / u_Resolution;

    vec4 moviecol;

    vec2 uvOffset = texture(u_NoiseTexture, vec2(u_Time*5.0)).rg;
    uvOffset.x *= 0.001;
    uvOffset.y *= 0.003;

    moviecol.r = texture(u_Texture, uv + uvOffset ).r;
    moviecol.g = vec4(texture(u_Texture, uv + uvOffset)).g;
    moviecol.b = texture(u_Texture, uv + uvOffset + vec2(-0.01*texture(u_NoiseTexture, vec2(uv.x/100.0,uv.y + u_Time*5.0)).r, 0) ).b;


    moviecol.rgb = mix(moviecol.rgb, vec3(dot(moviecol.rgb, vec3(.33))), 0.6);
    moviecol.a = 1.0;

    o_FragColor = vec4(moviecol);
}
