#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

void main() {
    float amount = sin(u_Time) * 0.1;

    // uv coords
    vec2 uv = gl_FragCoord.xy / u_Resolution;

    amount *= 0.3;
    float split = 1. - fract(u_Time / 2.);
    float scanOffset = 0.01;
    vec2 uv1 = vec2(uv.x + amount, uv.y);
    vec2 uv2 = vec2(uv.x, uv.y + amount);

    if (uv.y > split) {
        uv.x += scanOffset;
        uv1.x += scanOffset;
        uv2.x += scanOffset;
    }

    float r = texture(u_Texture, uv1).r;
    float g = texture(u_Texture, uv).g;
    float b = texture(u_Texture, uv2).b;

    o_FragColor = vec4(r, g, b, 1.);
}
