#version 300 es

precision highp float;

in vec2 v_TexCoord;

uniform vec2 u_Resolution;
uniform float u_Time;

layout(location = 0) out vec4 o_FragColor;

void boxReflect(inout float p, in float bbmin, in float bbmax)
{

    p =  bbmax-(abs(bbmax-mod( p - bbmin, (bbmax-bbmin)*2.) - bbmin));
    return;


    p = bbmin + mod(p-bbmin, 2.0*(bbmax - bbmin));
    if(p > bbmax)
    p = bbmax - (p - bbmax);

}

void boxReflect(inout vec2 p, in vec2 bbmin, in vec2 bbmax)
{
    boxReflect(p.x, bbmin.x, bbmax.x);
    boxReflect(p.y, bbmin.y, bbmax.y);
}

void main() {
    float radius = 0.1;
    float ratio = u_Resolution.x/u_Resolution.y;
    vec2 uv = gl_FragCoord.xy / u_Resolution.y;

    vec2 speed = normalize(vec2(1.0, sqrt(2.0))) * 0.5;
    vec2 p0 = vec2(0.5, 0.5) + u_Time*speed;

    boxReflect(p0, vec2(radius), vec2(ratio-radius,1.0-radius));

    float d = length(uv-p0);
    float dd = 0.0;
    if(d < radius)
    dd = 1.0;

    o_FragColor = vec4(vec3(dd, 0.0, 0.0), 1.0);
}
